Bug 507462

Summary: Cannot handle more than 1024 file descriptors
Product: [Fedora] Fedora Reporter: Ben Webb <ben>
Component: krb5Assignee: Nalin Dahyabhai <nalin>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: low Docs Contact:
Priority: low    
Version: 12CC: nalin
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2010-12-05 01:49:07 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Ben Webb 2009-06-22 16:43:08 EDT
Description of problem:
There appears to be a hardcoded limit of 1024 file descriptors somewhere in the code. If more than 1024 fds are opened, a segfault occurs in sendto_kdc.c. See bug 486006, comment 12 for one example.

Version-Release number of selected component (if applicable):
krb5-libs-1.6.3-18.fc10.i386
dovecot-1.1.10-1.fc10.i386
pam_krb5-2.3.2-1.fc10.i386

How reproducible:
Every day or so in normal operation on our setup.

Steps to Reproduce:
1. Set up dovecot and pam_krb5 as described in bug 486006.
2. Run IMAP server for several days under moderate load (20 or so users).
  
Actual results:
Periodically, IMAP worker processes drop connections (claiming they cannot contact the KDC). An strace (bug 486006, comment 1) reveals that fd #1024 is reported in error, even though nothing appears wrong with any of the KDCs. Eventually the same process will segfault as mentioned above.

Expected results:
IMAP server runs normally.

Additional info:
Note that this particular example requires the released version of pam_krb5, *not* the newer one currently in updates-testing (2.3.5-1). dovecot does not usually use more than 1024 file descriptors under this load. In fact, the problem is exposed by a bug in pam_krb5, fixed in 2.3.5-1, which leaks fds, so it will not be reproducible with latest pam_krb5. It may be possible, however, to construct a simpler testcase to trigger the bug, but I do not know the krb5 internals well enough for that. I can certainly help with testing or more information if necessary, however.
Comment 1 Bug Zapper 2009-11-18 07:53:37 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Nalin Dahyabhai 2009-11-20 10:51:57 EST
Haven't had a chance to work up a patch for this yet; moving to F12.
Comment 3 Bug Zapper 2010-11-04 07:01:47 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Ben Webb 2010-11-18 13:36:14 EST
I see this bug is marked 'needinfo' but I can't provide any additional information, sorry. As I said in the original report, the fd leakage which originally triggered this problem has now been fixed, so I'm not seeing the problem in production any more (furthermore, since then that machine was rebased to RHEL, so everything's different now).
Comment 5 Bug Zapper 2010-12-05 01:49:07 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.